function map = constructNameMap(skel)

% format:
% standard joint name, DOF ID, trajectory ID

switch skel.fileType
    case 'ASF'
map = {'root',1,1;...
       'lhip',3,2;...
       'lknee',4,3;...
       'lankle',5,4;...
       'ltoes',0,6;...
       'rhip',8,7;...
       'rknee',9,8;...
       'rankle',10,9;...
       'rtoes',0,11;...
       'belly',13,12;...
       'chest',14,13;...
       'neck',15,14;...
       'head',17,16;...
       'headtop',0,17;...
       'lclavicle',18,14;...
       'lshoulder',19,18;...
       'lelbow',20,19;...
       'lwrist',22,21;...
       'lfingers',0,23;...
       'rclavicle',25,14;...
       'rshoulder',26,25;...
       'relbow',27,26;...
       'rwrist',29,28;...
       'rfingers',0,30};
   case 'BVH'
map = {'root',1,1;...
       'lhip',19,18;...
       'lknee',20,19;...
       'lankle',21,20;...
       'ltoes',0,21;...
       'rhip',23,22;...
       'rknee',24,23;...
       'rankle',25,24;...
       'rtoes',0,25;...
       'belly',3,2;...
       'chest',17,3;...
       'neck',15,14;...
       'head',16,15;...
       'headtop',0,16;...
       'lclavicle',5,4;...
       'lshoulder',6,5;...
       'lelbow',7,6;...
       'lwrist',8,7;...
       'lfingers',0,8;...
       'rclavicle',10,9;...
       'rshoulder',11,10;...
       'relbow',12,11;...
       'rwrist',13,12;...
       'rfingers',0,13};
end