function drawCoordinateSystem(varargin)

global SCENE;

if ~ishandle(SCENE.handles.coordX)
    arrow_length = 50;

    vertices_x = [0.0 0.0 0.0;...
                  0.7 0.0 0.05;...
                  0.7 -0.05 0.0;...
                  0.7 0.0 -0.05;...
                  0.7 0.05 0.0;...
                  0.7 0.0 0.1;...
                  0.7 -0.1 0.0;...
                  0.7 0.0 -0.1;...
                  0.7 0.1 0.0;...
                  1.0 0.0 0.0];         

    vertices_y = quatrot(vertices_x',rotquat(pi/2,'z'))';
    vertices_z = quatrot(vertices_x',rotquat(-pi/2,'y'))';

    faces =    [  1 2 3;...
                  1 3 4;...
                  1 4 5;...
                  1 5 2;...
                  2 3 6;...
                  3 6 7;...
                  3 4 7;...
                  4 7 8;...
                  4 5 8;...
                  5 8 9;...
                  2 5 9;...
                  2 6 9;...
                  6 7 10;...
                  7 8 10;...
                  8 9 10;...
                  6 9 10];
              
              
    vertices_x = vertices_x*arrow_length;
    vertices_y = vertices_y*arrow_length;
    vertices_z = vertices_z*arrow_length;
                

    SCENE.handles.coordX = patch('Vertices',vertices_x,'Faces',faces,...
                            'FaceVertexCData',SCENE.colors.singleSkel_FaceVertexData,...
                            'FaceColor',[1 0 0],...
                            'FaceAlpha',0.2, ...
                            'EdgeColor',[1 0 0]);
    SCENE.handles.coordY = patch('Vertices',vertices_y,'Faces',faces,...
                            'FaceVertexCData',SCENE.colors.singleSkel_FaceVertexData,...
                            'FaceColor',[0 1 0],...
                            'FaceAlpha',0.2, ...
                            'EdgeColor',[0 1 0]);
    SCENE.handles.coordZ = patch('Vertices',vertices_z,'Faces',faces,...
                            'FaceVertexCData',SCENE.colors.singleSkel_FaceVertexData,...
                            'FaceColor',[0 0 1],...
                            'FaceAlpha',0.2, ...
                            'EdgeColor',[0 0 1]);
end

if SCENE.status.coordSyst_drawn
    SCENE.status.coordSyst_drawn = false;
    
    set(SCENE.handles.coordX,'Visible','off');
    set(SCENE.handles.coordY,'Visible','off');
    set(SCENE.handles.coordZ,'Visible','off');
    
    set(SCENE.handles.drawCoordSyst_Button,'CData',SCENE.buttons.coords+0.5,'TooltipString','draw coordinate system');
else
    SCENE.status.coordSyst_drawn = true;
    
    set(SCENE.handles.coordX,'Visible','on');
    set(SCENE.handles.coordY,'Visible','on');
    set(SCENE.handles.coordZ,'Visible','on');
                 
    set(SCENE.handles.drawCoordSyst_Button,'CData',SCENE.buttons.coords,'TooltipString','hide coordinate system');
end

end

